"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function () {
    return data;
  };
  return data;
}
function _react2() {
  const data = require("@teambit/react.mounter");
  _react2 = function () {
    return data;
  };
  return data;
}
function _tina() {
  const data = require("@sitestudio/tina.preview-form");
  _tina = function () {
    return data;
  };
  return data;
}
function _tinaPlugins() {
  const data = require("@sitestudio/tina.plugins.color-select");
  _tinaPlugins = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const parseColor = color => {
  let m;

  // Check if color matches 3/4 length hexcode
  m = color.match(/^#([0-9a-f]{3}|[0-9a-f]{4})$/i);
  if (m && m[1]) {
    // eslint-disable-next-line prefer-destructuring
    m = m[1];
    // in three-character format, each value is multiplied by 0x11 to give an
    // even scale from 0x00 to 0xff
    return {
      red: parseInt(m.charAt(0), 16) * 0x11,
      green: parseInt(m.charAt(1), 16) * 0x11,
      blue: parseInt(m.charAt(2), 16) * 0x11,
      alpha: m.length === 4 ? parseInt(m.charAt(3), 16) * 0x11 : 1
    };
  }

  // Check if color matches 6/8 length hexcode
  m = color.match(/^#([0-9a-f]{6}|[0-9a-f]{8})$/i);
  if (m && m[1]) {
    // eslint-disable-next-line prefer-destructuring
    m = m[1];
    return {
      red: parseInt(m.slice(0, 2), 16),
      green: parseInt(m.slice(2, 4), 16),
      blue: parseInt(m.slice(4, 6), 16),
      alpha: m.length === 8 ? parseInt(m.slice(6, 8), 16) : 1
    };
  }

  // Check if color matches rgb/rgba structure
  m = color.match(/^rgba?\s*\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*(?:,\s*(\d+)\s*)?\)$/i);
  if (m) {
    return {
      red: parseInt(m[1], 10),
      green: parseInt(m[2], 10),
      blue: parseInt(m[3], 10),
      alpha: m[4] ? parseInt(m[4], 10) : 1
    };
  }
  return {
    red: 0,
    green: 0,
    blue: 0,
    alpha: 1
  };
};
const buildColorChannelString = rgbColor => {
  if (!rgbColor) return '';

  // TODO: Handle the case where the color has an alpha value
  // const { red, green, blue, alpha } = parseColor(rgbColor)
  // if (alpha !== 1) {
  //   colorInfo[findMatchingOpacityName(key)] = alpha
  // }
  const {
    red,
    green,
    blue
  } = parseColor(rgbColor);
  return `${red}, ${green}, ${blue}`;
};
const CssColorVariables = ({
  colors
}) => {
  if (!Array.isArray(colors) || colors.length === 0) return null;
  const customVariables = colors.flatMap(({
    active,
    base,
    uniqueId
  }) => {
    return [`--color-id-${uniqueId}: ${buildColorChannelString(base)}`, `--color-id-${uniqueId}-active: ${buildColorChannelString(active)}`];
  }).join('; ');
  return /*#__PURE__*/_react().default.createElement("style", {
    type: "text/css",
    dangerouslySetInnerHTML: {
      __html: `:root { ${customVariables} }`
    }
    // dangerouslySetInnerHTML={{
    //   __html: `
    //   :root { 
    //     --tw-bg-opacity: 1;
    //     ${customVariables}
    //   };
    //   .bg-custom {
    //     background-color: rgba(var(--background-color), var(--tw-bg-opacity));
    //   }
    //   .bg-active {
    //     background-color: rgba(var(--background-color-active), var(--tw-bg-opacity));
    //   }`,
    // }}
  });
};
const ColorProvider = ({
  children
}) => {
  return /*#__PURE__*/_react().default.createElement(_react().default.Fragment, null, /*#__PURE__*/_react().default.createElement(CssColorVariables, {
    colors: _tinaPlugins().defaultColors
  }), children);
};

/**
 * provide your component compositions (preview) with the context they need to run.
 * for example, a router, a theme, a data provider, etc.
 * components added here as providers, should be listed as host-dependencies in your host-dependencies.ts file.
 * @see https://bit.dev/docs/react-env/component-previews#composition-providers
 */
function MyReactProvider({
  children
}) {
  // @ts-expect-error Property 'type' does not exist on type 'string | number | boolean | ReactElement<any, string | JSXElementConstructor<any>> | Iterable<ReactNode> | ReactPortal'. Property 'type' does not exist on type 'string'
  const Component = children === null || children === void 0 ? void 0 : children.type;
  const formConfig = Component.previewFormConfig;
  if (formConfig) {
    return /*#__PURE__*/_react().default.createElement(ColorProvider, null, /*#__PURE__*/_react().default.createElement(_tina().PreviewForm, _extends({}, formConfig, {
      Component: Component
      // renderBlock={(props) => <Component {...props} />}
    })));
  }
  return /*#__PURE__*/_react().default.createElement(ColorProvider, null, children);
}

/**
 * the entry for the app (preview runtime) that renders your component previews.
 * use the default template or create your own.
 * @see https://docs/react-env/component-previews#composition-mounter
 */
var _default = exports.default = (0, _react2().createMounter)(MyReactProvider);

//# sourceMappingURL=mounter.js.map