"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SitestudioReactEnv = void 0;
function _react() {
  const data = require("@teambit/react.react-env");
  _react = function () {
    return data;
  };
  return data;
}
function _preview() {
  const data = require("@teambit/preview.react-preview");
  _preview = function () {
    return data;
  };
  return data;
}
function _builder() {
  const data = require("@teambit/builder");
  _builder = function () {
    return data;
  };
  return data;
}
function _typescript() {
  const data = require("@teambit/typescript.typescript-compiler");
  _typescript = function () {
    return data;
  };
  return data;
}
function _defender() {
  const data = require("@teambit/defender.eslint-linter");
  _defender = function () {
    return data;
  };
  return data;
}
function _defender2() {
  const data = require("@teambit/defender.jest-tester");
  _defender2 = function () {
    return data;
  };
  return data;
}
function _defender3() {
  const data = require("@teambit/defender.prettier-formatter");
  _defender3 = function () {
    return data;
  };
  return data;
}
function _workspaceConfigFiles() {
  const data = require("@teambit/workspace-config-files");
  _workspaceConfigFiles = function () {
    return data;
  };
  return data;
}
function _stylingTransformers() {
  const data = require("@learnbit/styling.transformers.tailwind");
  _stylingTransformers = function () {
    return data;
  };
  return data;
}
function _stylingConfig() {
  const data = require("@learnbit/styling.config.tailwind");
  _stylingConfig = function () {
    return data;
  };
  return data;
}
function _generator() {
  const data = require("@teambit/generator");
  _generator = function () {
    return data;
  };
  return data;
}
function _templates() {
  const data = require("@sitestudio/templates.sitestudio-block");
  _templates = function () {
    return data;
  };
  return data;
}
function _hostDependencies() {
  const data = _interopRequireDefault(require("./preview/host-dependencies"));
  _hostDependencies = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
* this env extends react-env version 1.0.38.
* to inspect its config @see https://bit.cloud/teambit/react/react-env?version=1.0.38
* */ // import { webpackTransformer } from './config/webpack.config';
// @ts-ignore File '/sitestudio-bit/templates/sitestudio-block/index.ts' is not under 'rootDir' '/sitestudio-bit/envs'. 'rootDir' is expected to contain all source files
class SitestudioReactEnv extends _react().ReactEnv {
  constructor(...args) {
    super(...args);
    /* a shorthand name for the env */
    _defineProperty(this, "name", 'sitestudio-react-env');
    _defineProperty(this, "tsconfigPath", require.resolve('./config/tsconfig.json'));
    _defineProperty(this, "tsTypesPath", './types');
    _defineProperty(this, "jestConfigPath", require.resolve('./config/jest.config'));
    _defineProperty(this, "eslintConfigPath", require.resolve('./config/eslintrc.js'));
    _defineProperty(this, "eslintExtensions", ['.ts', '.tsx', '.js', '.jsx', '.mjs']);
    _defineProperty(this, "prettierConfigPath", require.resolve('./config/prettier.config.js'));
    _defineProperty(this, "prettierExtensions", ['.js', '.jsx', '.ts', '.tsx', '.mjs', '.cjs', '.json', '.css', '.scss', '.md', '.mdx', '.html', '.yml', '.yaml']);
    _defineProperty(this, "previewMounter", require.resolve('./preview/mounter'));
  }
  /* the compiler to use during development */
  compiler() {
    /**
     * @see https://bit.dev/reference/typescript/using-typescript
     * */
    return _typescript().TypescriptCompiler.from({
      tsconfig: this.tsconfigPath,
      types: (0, _typescript().resolveTypes)(__dirname, [this.tsTypesPath])
    });
  }

  /* the test runner to use during development */
  tester() {
    /**
     * @see https://bit.dev/reference/jest/using-jest
     * */
    return _defender2().JestTester.from({
      config: this.jestConfigPath
    });
  }

  /* the linter to use during development */
  linter() {
    /**
     * @see https://bit.dev/reference/eslint/using-eslint
     * */
    return _defender().ESLintLinter.from({
      tsconfig: this.tsconfigPath,
      configPath: this.eslintConfigPath,
      pluginsPath: __dirname,
      extensions: this.eslintExtensions
    });
  }

  /**
   * the formatter to use during development
   * (source files are not formatted as part of the components' build)
   * */
  formatter() {
    /**
     * @see https://bit.dev/reference/prettier/using-prettier
     * */
    return _defender3().PrettierFormatter.from({
      configPath: this.prettierConfigPath
    });
  }

  /**
   * generates the component previews during development and during build
   */
  preview() {
    /**
     * @see https://bit.dev/docs/react-env/component-previews
     */
    return _preview().ReactPreview.from({
      mounter: this.previewMounter,
      docsTemplate: require.resolve('./preview/docs-template'),
      hostDependencies: _hostDependencies().default,
      // transformers: [webpackTransformer],
      transformers: [(0, _stylingTransformers().tailwindTransformer)({
        cdn: true,
        config: {
          content: [..._stylingConfig().bitPreset.content],
          // content: [],
          theme: {
            extend: {
              backgroundColor: {
                custom: 'rgba(var(--background-color, <alpha-value>))',
                active: 'rgba(var(--active-background-color, <alpha-value>))'
              }
              // plugins: [require("@tailwindcss/container-queries")]
            }
          }
        }
      })]
    });
  }

  /**
   * a set of processes to be performed before a component is snapped, during its build phase
   * @see https://bit.dev/docs/react-env/build-pipelines
   */
  build() {
    return _builder().Pipeline.from([_typescript().TypescriptTask.from({
      tsconfig: this.tsconfigPath,
      types: (0, _typescript().resolveTypes)(__dirname, [this.tsTypesPath])
    }), _defender().EslintTask.from({
      tsconfig: this.tsconfigPath,
      configPath: this.eslintConfigPath,
      pluginsPath: __dirname,
      extensions: this.eslintExtensions
    }), _defender2().JestTask.from({
      config: this.jestConfigPath
    })]);
  }
  workspaceConfig() {
    return _workspaceConfigFiles().ConfigWriterList.from([_typescript().TypescriptConfigWriter.from({
      tsconfig: this.tsconfigPath,
      types: (0, _typescript().resolveTypes)(__dirname, [this.tsTypesPath])
    }), _defender().EslintConfigWriter.from({
      configPath: this.eslintConfigPath,
      tsconfig: this.tsconfigPath
    }), _defender3().PrettierConfigWriter.from({
      configPath: this.prettierConfigPath
    })]);
  }
  generators() {
    return _generator().TemplateList.from([_templates().SitestudioBlockComponentTemplate.from()]);
  }
}
exports.SitestudioReactEnv = SitestudioReactEnv;
var _default = exports.default = new SitestudioReactEnv();

//# sourceMappingURL=sitestudio-react-env.bit-env.js.map